module Boggler
  module Core
    extend self

    def run
      start
      Solver.solve @grid
    end

    def game
      start

      time = Time.now
      Dictionary.words
      while Time.now - time < 3 * 60 do
      end

      puts "\n" * 100

      Solver.solve @grid
    end

    def seed
      return @seed if defined?(@seed)
      #@seed = 7567 # postdated appears
      #@seed = 532183 # used for construction of grid word construction
      @seed = rand(999_999)
      srand @seed
      @seed
    end

    private

    def start
      seed
      puts "Randomized with seed #{seed}"
      @grid = Grid.new
      puts @grid.to_s
    end
  end
end
