module Boggler
  module Dice
    extend self

    BOGGLE_DICE = [
      Die.new(%W{a a c i o t}),
      Die.new(%W{a h m o r s}),
      Die.new(%W{e g k l u y}),
      Die.new(%W{a b i l t y}),
      Die.new(%W{a c d e m p}),
      Die.new(%W{e g i n t v}),
      Die.new(%W{g i l r u w}),
      Die.new(%W{e l p s t u}),
      Die.new(%W{d e n o s w}),
      Die.new(%W{a c e l r s}),
      Die.new(%W{a b j m o q}),
      Die.new(%W{e e f h i y}),
      Die.new(%W{e h i n p s}),
      Die.new(%W{d k n o t u}),
      Die.new(%W{a d e n v z}),
      Die.new(%W{b i f o r x}),
    ]

    STATIC_BOGGLE = [
      Die.new(%W{e g i n t v}),
      Die.new(%W{e l p s t u}),
      Die.new(%W{a b j m o q}),
      Die.new(%W{e h i n p s}),
      Die.new(%W{d k n o t u}),
      Die.new(%W{a d e n v z}),
      Die.new(%W{b i f o r x}),
    ].shuffle

    STATIC_DICE = [
      Die.new(['h']),
      Die.new(['e']),
      Die.new(['a']),
      Die.new(['r']),
      STATIC_BOGGLE[0],
      Die.new(['o']),
      Die.new(['r']),
      STATIC_BOGGLE[1],
      STATIC_BOGGLE[2],
      STATIC_BOGGLE[3],
      Die.new(['m']),
      STATIC_BOGGLE[4],
      STATIC_BOGGLE[5],
      STATIC_BOGGLE[6],
      Die.new(['y']),
      Die.new(['e']),
    ]

    def get(opts = {})
      opts ||= {}

      case opts[:method]
      when :random
        random_dice
      when :boggle
        BOGGLE_DICE.shuffle
      when :big_boggle
        [
          BOGGLE_DICE.shuffle,
          BOGGLE_DICE.shuffle,
          BOGGLE_DICE.shuffle,
          BOGGLE_DICE.shuffle,
        ].flatten
      when :static
        STATIC_DICE
      else
        BOGGLE_DICE.shuffle
      end
    end

    private

    def random_dice
      16.times.map do
        Die.new
      end
    end
  end
end
