module Boggler
  module Solver
    extend self

    def solve(grid)
      Dictionary.words

      Benchmarking.measure('solution') do
        grid.words.each do |word|
          add_word word
        end
      end
    end

    private

    def words
      @words ||= Set.new
    end

    def add_word(word)
      length = words.length
      words << word
      puts word if words.length > length
    end
  end
end
